#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       server.py
#       
#       Copyright 2013 Recursos Python - www.recursospython.com
#       
#

import asyncore
from socket import AF_INET, SOCK_STREAM


# Diccionario para cada uno de los clientes.
# No es lo más recomendado usar variables globales.
clients = {}

class TCPHandler(asyncore.dispatcher_with_send):
    
    def __init__(self, conn):
        asyncore.dispatcher_with_send.__init__(self, conn)
        self.addr = "%s:%d" % self.addr
    
    def handle_read(self):
        """Enviar el mensaje recibido a cada uno de los clientes"""
        data = self.recv(1024)
        if data:
            for client in clients:
                clients[client].send("%s dice: %s" % (self.addr, data))
    
    def handle_close(self):
        print self.addr + " se ha desconectado."
        del clients[self.addr]
        self.close()


class TCPServer(asyncore.dispatcher):

    def __init__(self, port):
        asyncore.dispatcher.__init__(self)
        self.create_socket(AF_INET, SOCK_STREAM)
        self.set_reuse_addr()
        self.bind(("localhost", port))
        self.listen(20)

    def handle_accept(self):
        client = self.accept()
        if client is not None:
            conn, addr = client
            handler = TCPHandler(conn)
            clients[handler.addr] = handler
            print handler.addr + " se ha conectado."


if __name__ == "__main__":
    server = TCPServer(6000)
    asyncore.loop()
